# Slash Shortcuts

**Slash Shortcuts** is a handy tool designed to make handling and sharing links in your digital workspace a breeze.

## What is a Shortcut?

A Shortcut is a simplified version of a link with essential details, making it easy to remember, organize, and share. Let's break down the key elements:

- **Name:** Your chosen label for the Shortcut. This becomes a crucial part of the URL, enabling direct and quick access to the Shortcut. For example, if your Shortcut is named "meet-john", the direct access link would be `s/meet-john`. This user-defined name significantly enhances the accessibility and recognition of your Shortcuts.
- **Link:** The original web link you want to streamline.
- **Title:** A quick overview of what's behind the link.
- **Tags:** Custom labels for easy sorting.
- **Description:** A short summary of the content.
- **Visibility:** Controls who can access the Shortcut.

## How to Use Shortcuts

### Creating a Shortcut

1. **Define the Link:** Paste the original link you want to simplify.
2. **Add Details:** Give it a name, tags, and a brief description for better organization.
3. **Set Visibility:** Choose who should be able to access the Shortcut.
4. **Save:** Once saved, your Shortcut is ready to go.

### Accessing Shortcuts

#### Direct Access

Effortlessly access your Shortcut's content directly by using the assigned name as part of the Slash Shortcuts format.

For example, if your Shortcut is named "meet-john", the direct access link would be `{YOUR_DOMAIN}/s/meet-john`. Simply enter this user-friendly shortcut into your browser to reach the associated content with ease.

#### Browser Extension Access

Install the Slash Shortcuts browser extension for even quicker access. Once installed, simply type `s/meet-john` into your browser's address bar, and the extension will seamlessly redirect you to the corresponding page.

### Updating and Managing Shortcuts

Adjust attributes like name and tags to update a Shortcut. Keep your Shortcuts organized based on categories and visibility settings.

### Sharing Shortcuts

Share Shortcuts by providing the assigned name to collaborators for easy access.

## Conclusion

Shortcuts provide a simple way to manage, organize, and share links within your digital workspace. By using the defined Shortcut attributes, users can easily create, access, and share information, promoting collaboration and boosting productivity.
